Package org.apache.groovy.contracts.ast

# Class MethodVariantASTTransformation

java.lang.Object
org.apache.groovy.contracts.ast.MethodVariantASTTransformation

All Implemented Interfaces:
  `ASTTransformation`

public class MethodVariantASTTransformation extends Object implements ASTTransformation
Handles a `Decreases` annotation placed on a method (the loop case is handled by `LoopVariantASTTransformation`). The closure is a termination measure over the method's parameters that must strictly decrease, and stay non-negative, on every recursive re-entry.

The method body is wrapped so that, conceptually:

     def $m   = <measure>
     def $prev = MethodVariantSupport.enter("<key>", $m)   // checks decrease vs the enclosing frame
     try { <original body> } finally { MethodVariantSupport.exit("<key>", $prev) }

The check is pure entry/exit bookkeeping keyed by method signature, so no static analysis of recursive call sites is needed.

Since:
  6.0.0
See Also:
  - `Decreases`
  - `MethodVariantSupport`

- ## Constructor Summary

  Constructors
  Constructor
  Description
  `MethodVariantASTTransformation()`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `void`
  `visit(ASTNode[] nodes, SourceUnit source)`
  The method is invoked when an AST Transformation is active.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### MethodVariantASTTransformation

    public MethodVariantASTTransformation()

- ## Method Details

  - ### visit

    public void visit(ASTNode[] nodes, SourceUnit source)
    Description copied from interface: `ASTTransformation`
    The method is invoked when an AST Transformation is active. For local transformations, it is invoked once each time the local annotation is encountered. For global transformations, it is invoked once for every source unit, which is typically a source file.
    Specified by:
      `visit` in interface `ASTTransformation`
    Parameters:
      `nodes` - The ASTnodes when the call was triggered. Element 0 is the AnnotationNode that triggered this annotation to be activated. Element 1 is the AnnotatedNode decorated, such as a MethodNode or ClassNode. For global transformations it is usually safe to ignore this parameter.
      `source` - The source unit being compiled. The source unit may contain several classes. For global transformations, information about the AST can be retrieved from this object.